/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.client.render;

import net.minecraft.class_1309;
import net.minecraft.class_1799;
import net.minecraft.class_3883;
import net.minecraft.class_3887;
import net.minecraft.class_4587;
import net.minecraft.class_4597;
import net.minecraft.class_583;
import top.theillusivec4.curios.api.CuriosApi;
import top.theillusivec4.curios.api.type.inventory.IDynamicStackHandler;

public class CuriosFeatureRenderer<T extends class_1309, M extends class_583<T>> extends
    class_3887<T, M> {

  public CuriosFeatureRenderer(class_3883<T, M> context) {
    super(context);
  }

  public void render(class_4587 matrices, class_4597 vertexConsumers, int light,
      T entity, float limbAngle, float limbDistance, float tickDelta, float animationProgress,
      float headYaw, float headPitch) {
    matrices.method_22903();
    CuriosApi.getCuriosHelper().getCuriosHandler(entity)
        .ifPresent(handler -> handler.getCurios().forEach((id, stacksHandler) -> {
          IDynamicStackHandler stackHandler = stacksHandler.getStacks();
          IDynamicStackHandler cosmeticStacksHandler = stacksHandler.getCosmeticStacks();

          for (int i = 0; i < stackHandler.method_5439(); i++) {
            class_1799 stack = cosmeticStacksHandler.method_5438(i);

            if (stack.method_7960() && stacksHandler.getRenders().get(i)) {
              stack = stackHandler.method_5438(i);
            }

            if (!stack.method_7960()) {
              int index = i;

              CuriosApi.getCuriosHelper().getRenderableCurio(stack).ifPresent(curio -> {
                matrices.method_22903();
                curio.render(id, index, matrices, vertexConsumers, light, entity, limbAngle,
                    limbDistance, tickDelta, animationProgress, headYaw, headPitch);
                matrices.method_22909();
              });
            }
          }
        }));
    matrices.method_22909();
  }
}
