/*
 * Copyright (c) 2018-2020 C4
 *
 * This file is part of Curios, a mod made for Minecraft.
 *
 * Curios is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Curios is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Curios.  If not, see <https://www.gnu.org/licenses/>.
 */

package top.theillusivec4.curios.client.screen;

import io.netty.buffer.Unpooled;
import net.fabricmc.fabric.api.network.ClientSidePacketRegistry;
import net.minecraft.class_1761;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_344;
import net.minecraft.class_3545;
import net.minecraft.class_4587;
import net.minecraft.class_465;
import net.minecraft.class_481;
import net.minecraft.class_490;
import net.minecraft.class_507;
import top.theillusivec4.curios.common.CuriosNetwork;
import top.theillusivec4.curios.mixin.IHandledScreenAccessor;
import top.theillusivec4.curios.mixin.IInventoryScreenAccessor;

public class CuriosButton extends class_344 {

  private final class_465<?> parentGui;
  private boolean isRecipeBookOpen = false;

  public CuriosButton(class_465<?> parentGui, int xIn, int yIn, int widthIn, int heightIn,
      int textureOffsetX, int textureOffsetY, int yDiffText, class_2960 identifier) {

    super(xIn, yIn, widthIn, heightIn, textureOffsetX, textureOffsetY, yDiffText, identifier,
        (button) -> {
          class_310 mc = class_310.method_1551();

          if (parentGui instanceof CuriosScreen && mc.field_1724 != null) {
            class_490 inventory = new class_490(mc.field_1724);
            class_1799 stack = mc.field_1724.field_7514.method_7399();
            mc.field_1724.field_7514.method_7396(class_1799.field_8037);
            float mouseX = ((CuriosScreen) parentGui).currentMouseX;
            float mouseY = ((CuriosScreen) parentGui).currentMouseY;
            mc.method_1507(inventory);
            @SuppressWarnings("ConstantConditions") IInventoryScreenAccessor accessor = (IInventoryScreenAccessor) inventory;
            accessor.setMouseX(mouseX);
            accessor.setMouseY(mouseY);
            mc.field_1724.field_7514.method_7396(stack);
            ClientSidePacketRegistry.INSTANCE
                .sendToServer(CuriosNetwork.OPEN_VANILLA, new class_2540(Unpooled.buffer()));
          } else {

            if (parentGui instanceof class_490) {
              class_490 inventory = (class_490) parentGui;
              class_507 recipeBookGui = inventory.method_2659();

              if (recipeBookGui.method_2605()) {
                recipeBookGui.method_2591();
              }
            }
            ClientSidePacketRegistry.INSTANCE
                .sendToServer(CuriosNetwork.OPEN_CURIOS, new class_2540(Unpooled.buffer()));
          }
        });
    this.parentGui = parentGui;
  }

  @Override
  public void method_25359(class_4587 matrixStack, int mouseX, int mouseY, float partialTicks) {

    if (parentGui instanceof class_490) {
      boolean lastOpen = isRecipeBookOpen;
      isRecipeBookOpen = ((class_490) parentGui).method_2659().method_2605();

      if (lastOpen != isRecipeBookOpen) {
        class_3545<Integer, Integer> offsets = CuriosScreen.getButtonOffset(false);
        this.method_1893(((IHandledScreenAccessor) parentGui).getX() + offsets.method_15442(),
            parentGui.field_22790 / 2 + offsets.method_15441());
      }
    } else if (parentGui instanceof class_481) {
      class_481 gui = (class_481) parentGui;
      boolean isInventoryTab = gui.method_2469() == class_1761.field_7918.method_7741();
      this.field_22763 = isInventoryTab;

      if (!isInventoryTab) {
        return;
      }
    }
    super.method_25359(matrixStack, mouseX, mouseY, partialTicks);
  }
}
